// -------------------------------------------------------------------------------
// 
// 		cwCu		ff[^ǂݍ݃wb_
// 
// 				Ver 3.17e
// 
// -------------------------------------------------------------------------------

#ifndef __DXMODELREAD_H__
#define __DXMODELREAD_H__

#include "DxCompileConfig.h"

#ifndef DX_NON_MODEL

// CN[h ---------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxModel.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` -----------------------------------

#define MV1_READ_MAX_UV_NUM						(8)				// ̒_Ŏgpłőtu
#define MV1_READ_MAX_MESH_MATERIAL_NUM			(1024)			// ̃bVŎgpł}eA̍ő吔
#define MV1_READ_MAX_MESH_SKINWEIGHT_NUM		(4096)			// ̃bVŎgpłXLEGCg̍ő吔

// f[^^` ---------------------------------

// Cg\
struct MV1_LIGHT_R
{
	MV1_LIGHT_R				*DataPrev ;						// (ǂݎp)f[^IɑÕCg
	MV1_LIGHT_R				*DataNext ;						// (ǂݎp)f[^IɎ̃Cg
	int						Index ;							// (ǂݎp)CfbNX
#ifndef UNICODE
	char					*NameA ;						// (ǂݎp)O
#endif
	wchar_t					*NameW ;						// (ǂݎp)O

	int						FrameIndex ;					// CgĂt[̃CfbNX
	int						Type ;							// Cg^Cv( MV1_LIGHT_TYPE_POINT  )
	COLOR_F					Diffuse ;						// fBt[YJ[
	COLOR_F					Specular ;						// XyLJ[
	COLOR_F					Ambient ;						// ArGgJ[
	float					Range ;							// X|bgCg̗L
	float					Falloff ;						// tH[It
	float					Attenuation0 ;					// Cgp[^O
	float					Attenuation1 ;					// Cgp[^P
	float					Attenuation2 ;					// Cgp[^Q
	float					Theta ;							// X|bgCg̓R[̊px͈
	float					Phi ;							// X|bgCg̊OR[̊px͈
} ;

// Aj[VL[Zbg\
struct MV1_ANIMKEYSET_R
{
	MV1_ANIMKEYSET_R					*DataPrev ;				// (ǂݎp)f[^IɈÕAj[VL[Zbg
	MV1_ANIMKEYSET_R					*DataNext ;				// (ǂݎp)f[^IɈ̃Aj[VL[Zbg
	int									Index ;					// (ǂݎp)CfbNX

	char								Type ;					// L[^Cv( MV1_ANIMKEY_TYPE_QUATERNION  )
	char								DataType ;				// f[^^Cv( MV1_ANIMKEY_DATATYPE_ROTATE  )
	char								TimeType ;				// ԃ^Cv( MV1_ANIMKEY_TIME_TYPE_KEY  )
	int									TargetShapeIndex ;		// Ώۂ̃VFCvCfbNX( DataType  MV1_ANIMKEY_DATATYPE_SHAPE ̏ꍇ̂ݗL )

	float								TotalTime ;				// 
	int									Num ;					// L[̐

	float								UnitTime ;				// Pʎ( TimeType  MV1_ANIMKEY_TIME_TYPE_ONE ̏ꍇ̂ݗL )
	union
	{
		float							*KeyTime ;				// L[Ԕzւ̃|C^( TimeType  MV1_ANIMKEY_TIME_TYPE_KEY ̏ꍇ̂ݗL )
		float							StartTime ;				// Jn( TimeType  MV1_ANIMKEY_TIME_TYPE_ONE ̏ꍇ̂ݗL )
	} ;

	union
	{
		FLOAT4							*KeyFloat4 ;			// float4L[zւ̃|C^
		VECTOR							*KeyVector ;			// xN^[L[zւ̃|C^
		MV1_ANIM_KEY_MATRIX4X4C			*KeyMatrix4x4C ;		// SڏȗS~SsL[zւ̃|C^
		MV1_ANIM_KEY_MATRIX3X3			*KeyMatrix3x3 ;			// RRsL[zւ̃|C^
		float							*KeyFlat ;				// tbgL[zւ̃|C^
		float							*KeyLinear ;			// `ԃL[zւ̃|C^
	} ;

	MV1_ANIMKEYSET_R					*Prev ;					// (ǂݎp)ÕAj[VL[Zbgւ̃|C^
	MV1_ANIMKEYSET_R					*Next ;					// (ǂݎp)̃Aj[VL[Zbgւ̃|C^
} ;

// Aj[V\
struct MV1_ANIM_R
{
	struct MV1_ANIMSET_R	*Container ;					// (ǂݎp)̃f[^܂łAj[VZbgւ̃|C^

	MV1_ANIM_R				*DataPrev ;						// (ǂݎp)f[^IɈÕAj[V
	MV1_ANIM_R				*DataNext ;						// (ǂݎp)f[^IɈ̃Aj[V
	int						Index ;							// (ǂݎp)CfbNX

	int						TargetFrameIndex ;				// ΏۂƂȂm[h̃CfbNX
	float					MaxTime ;						// eL[Zbg̒ňԒL[Zbg̎Ԓl
	int						RotateOrder ;					// ]I[_[( MV1_ROTATE_ORDER_XYZ  )

	int						AnimKeySetNum ;					// (ǂݎp)L[Zbg̐
	MV1_ANIMKEYSET_R		*AnimKeySetFirst ;				// (ǂݎp)擪̃L[Zbg
	MV1_ANIMKEYSET_R		*AnimKeySetLast ;				// (ǂݎp)[̃L[Zbg

	MV1_ANIM_R				*Prev ;							// (ǂݎp)ÕAj[V
	MV1_ANIM_R				*Next ;							// (ǂݎp)̃Aj[V
} ;

// Aj[VZbg\
struct MV1_ANIMSET_R
{
	MV1_ANIMSET_R			*DataPrev ;						// (ǂݎp)f[^IɈÕAj[VZbg
	MV1_ANIMSET_R			*DataNext ;						// (ǂݎp)f[^IɈ̃Aj[VZbg
	int						Index ;							// (ǂݎp)CfbNX
#ifndef UNICODE
	const char				*NameA ;						// (ǂݎp)O
#endif
	const wchar_t			*NameW ;						// (ǂݎp)O

	float					StartTime ;						// Jn
	float					EndTime ;						// I
	int						IsAddAnim ;						// ZAj[Vǂ( 1:ZAj[V  0:ΒlAj[V )
	int						IsMatrixLinearBlend ;			// eL[̕ԂsPʂŐ`Ԃ邩ǂ̃tO( 1:sŐ`  0:vfPʂŕ )
	int						IsLoopAnim ;					// [vpAj[Vǂ( 1:[vAj[V  0:ʏAj[V )

	int						AnimNum ;						// (ǂݎp)Aj[Vf[^̐
	MV1_ANIM_R				*AnimFirst ;					// (ǂݎp)擪̃Aj[V
	MV1_ANIM_R				*AnimLast ;						// (ǂݎp)[̃Aj[V
} ;

// eNX`\
struct MV1_TEXTURE_R
{
	MV1_TEXTURE_R			*DataPrev ;						// (ǂݎp)f[^IɑÕeNX`
	MV1_TEXTURE_R			*DataNext ;						// (ǂݎp)f[^IɎ̃eNX`
	int						Index ;							// (ǂݎp)CfbNX
#ifndef UNICODE
	const char				*NameA ;						// (ǂݎp)IuWFNgl[
#endif
	const wchar_t			*NameW ;						// (ǂݎp)IuWFNgl[

	void					*UserData ;						// [U[f[^

	int						AddressModeU ;					// AhX[h( MV1_TEXTURE_ADDRESS_MODE_WRAP  )
	int						AddressModeV ;					// AhX[h( MV1_TEXTURE_ADDRESS_MODE_WRAP  )
	float					ScaleU ;						// tW̃XP[Ol
	float					ScaleV ;						// uW̃XP[Ol
	int						FilterMode ;					// tB^O[h( MV1_TEXTURE_FILTER_MODE_POINT  )

#ifndef UNICODE
	char					*ColorFileNameA ;				// (ǂݎp)fBt[YeNX`t@C
#endif
	wchar_t					*ColorFileNameW ;				// (ǂݎp)fBt[YeNX`t@C
#ifndef UNICODE
	char					*AlphaFileNameA ;				// (ǂݎp)At@`lpeNX`t@C
#endif
	wchar_t					*AlphaFileNameW ;				// (ǂݎp)At@`lpeNX`t@C
	int						BumpMapFlag ;					// (ǂݎp)J[`lov}bvǂ( TRUE:ov}bv  FALSE:Ⴄ )
	float					BumpMapNextPixelLength ;		// (ǂݎp)J[`lov}bvꍇ́ÃׂsNZƂ̋
	int						BlendType ;						// uh^Cv( MV1_LAYERBLEND_TYPE_TRANSLUCENT  )

	int						ReverseFlag ;					// 摜𔽓]邩ǂ( 1:]  0:]Ȃ )
	int						Bmp32AllZeroAlphaToXRGB8Flag ;	// RQrbgalõAt@lSOXRGB8Ƃ邩ǂ( 1:  0:Ȃ )
} ;

// }eA\
struct MV1_MATERIAL_R
{
	MV1_MATERIAL_R			*DataPrev ;						// (ǂݎp)f[^IɑÕ}eA
	MV1_MATERIAL_R			*DataNext ;						// (ǂݎp)f[^IɎ̃}eA
	int						Index ;							// (ǂݎp)CfbNX
#ifndef UNICODE
	const char				*NameA ;						// (ǂݎp)O
#endif
	const wchar_t			*NameW ;						// (ǂݎp)O
	const char				*SubName ;						// ǂݍݏ̖OɎgp閼O

	void					*UserData ;						// [U[f[^

	int						Type ;							// }eA^Cv( DX_MATERIAL_TYPE_NORMAL Ȃ )

	int						DisableBackCulling ;			// obNJOsȂǂ( TRUE:obNOsȂ  FALSE:obNOs )

	int						DiffuseTexNum ;					// fBt[YeNX`̐
	MV1_TEXTURE_R			*DiffuseTexs[ 256 ] ;			// fBt[YeNX`ւ̃|C^̔z
	int						SpecularTexNum ;				// XyLeNX`̐
	MV1_TEXTURE_R			*SpecularTexs[ 256 ] ;			// XyLeNX`ւ̃|C^̔z
	int						NormalTexNum ;					// @}bveNX`̐
	MV1_TEXTURE_R			*NormalTexs[ 256 ] ;			// @}bveNX`ւ̃|C^̔z

	COLOR_F					Ambient ;						// ArGg
	COLOR_F					Diffuse ;						// fBt[Y
	COLOR_F					Specular ;						// XyL
	COLOR_F					Emissive ;						// G~bVu
//	float					Shininess ;						// 
//	float					Reflection ;					// 
	float					Power ;							// ˂̋
//	float					Alpha ;							// At@l

	int						DiffuseGradTextureDefault ;		// ( gD[_Oł̂ݎgp )fBt[YJ[Of[VeNX`ȂƂɎgpftHgOf[VeNX`^Cv
	int						SpecularGradTextureDefault ;	// ( gD[_Oł̂ݎgp )XyLJ[Of[VeNX`ȂƂɎgpftHgOf[VeNX`^Cv
	MV1_TEXTURE_R			*DiffuseGradTexture ;			// ( gD[_Oł̂ݎgp )fBt[YJ[Of[VeNX`AĂ郉Cg̃fBt[YJ[łtl܂
	MV1_TEXTURE_R			*SpecularGradTexture ;			// ( gD[_Oł̂ݎgp )XyLJ[Of[VeNX`AĂ郉Cg̃XyLJ[łtl܂
	MV1_TEXTURE_R			*SphereMapTexture ;				// ( gD[_Oł̂ݎgp )XtBA}bveNX`CfbNX
	int						DiffuseGradBlendType ;			// ( gD[_Oł̂ݎgp )fBt[YOf[VeNX`̃uh^Cv( MV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃ )
	int						SpecularGradBlendType ;			// ( gD[_Oł̂ݎgp )XyLOf[VeNX`̃uh^Cv( MV1_LAYERBLEND_TYPE_ADDITIVE Ȃ )
	int						SphereMapBlendType ;			// ( gD[_Oł̂ݎgp )XtBA}bveNX`̃uh^Cv( DX_MATERIAL_BLENDTYPE_ADDITIVE Ȃ )
	float					OutLineWidth ;					// ( gD[_Oł̂ݎgp )֊s̕
	float					OutLineDotWidth ;				// ( gD[_Oł̂ݎgp )֊s̃hbgPʂł̕
	COLOR_F					OutLineColor ;					// ( gD[_Oł̂ݎgp )֊s̐F

	int						DrawBlendMode ;					// õ͎uh[h( DX_BLENDMODE_NOBLEND  )
	int						DrawBlendParam ;				// õ͎uhp[^
} ;

// ʏ\
struct MV1_MESHFACE_R
{
	DWORD					IndexNum ;							// _CfbNX̐
	DWORD					PolygonNum ;						// (ǂݎp)Rp`|S̐
	DWORD					*VertexIndex ;						// _CfbNX
	DWORD					*NormalIndex ;						// @CfbNX
	DWORD					*VertexColorIndex ;					// _J[CfbNX
	DWORD					*UVIndex[ MV1_READ_MAX_UV_NUM ] ;	// tuCfbNX
	DWORD					MaterialIndex ;						// }eACfbNX
	VECTOR					Normal ;							// ʂ̖@( @vZɎgp )
} ;

// gCAOXgp̏(Ro[gvOgp)
struct MV1_TRIANGLELIST_R
{
	int						UseBoneNum ;						// gpĂ{[̐
	unsigned short			UseBone[ MV1_TRIANGLE_LIST_USE_BONE_MAX_NUM ] ;	// {[̃Xg( Mesh.SkinWeights z̃CfbNX )
	int						PolyNum ;							// |S̐
} ;

// }eÃ|S(Ro[gvOgp)
struct MV1_MATERIAL_POLY_R
{
	DWORD					TypeNum[ MV1_VERTEX_TYPE_NUM ] ;	// ^Cvʂ̃gCAO̐( Op`|SZ )
	int						MaxBoneCount ;						// ̃|SɊւĂő{[
	int						SimpleTriangleListNum ;				// ̃bṼgCAOXg̐
	MV1_TRIANGLELIST_R		SimpleTriangleList[ 128 ] ;			// ̃bṼgCAOXg̏
	int						SkinB4TriangleListNum ;				// {[Sȓ̃XLjObṼgCAOXg̐
	MV1_TRIANGLELIST_R		SkinB4TriangleList[ 128 ] ;			// {[Sȓ̃XLjObṼgCAOXg̏
	int						SkinB8TriangleListNum ;				// {[Sȓ̃XLjObṼgCAOXg̐
	MV1_TRIANGLELIST_R		SkinB8TriangleList[ 128 ] ;			// {[Sȓ̃XLjObṼgCAOXg̏
} ;

// XL̂P_̏
struct MV1_SKIN_WEIGHT_ONE_R
{
	DWORD					TargetVertex ;						// ΏۂƂȂ钸_ԍ
	float					Weight ;							// EGCg
} ;

// XL
struct MV1_SKIN_WEIGHT_R
{
	void					*UserData ;							// [U[f[^

	MATRIX					ModelLocalMatrix ;					// {[[J̍Wɂ邽߂̍s
	DWORD					TargetFrameUserID ;					// Ώۃt[̃[U[hc
	DWORD					TargetFrame ;						// Ώۃt[̃CfbNX
	DWORD					DataNum ;							// f[^̐
	MV1_SKIN_WEIGHT_ONE_R	*Data ;								// f[^z
} ;

// f[^bV\
struct MV1_MESH_R
{
	MV1_MESH_R				*DataPrev ;											// (ǂݎp)f[^IɑÕbV
	MV1_MESH_R				*DataNext ;											// (ǂݎp)f[^IɎ̃bV
	int						Index ;												// (ǂݎp)CfbNX

	void					*UserData ;											// [U[f[^

	DWORD					FaceNum ;											// (ǂݎp)ʂ̐
	MV1_MESHFACE_R			*Faces ;											// (ǂݎp)ʏz
	DWORD					*FaceIndexBuffer ;									// (ǂݎp)ʂ̃CfbNXobt@
	DWORD					FaceUnitMaxIndexNum ;								// (ǂݎp)̖ʂ̍őCfbNXl

	DWORD					PositionNum ;										// _ʒu̐
	VECTOR					*Positions ;										// _ʒuz
	float					*PositionToonOutLineScale ;							// gD[_O̗֊s̃XP[

	DWORD					NormalNum ;											// @̐
	VECTOR					*Normals ;											// @z
	BYTE					*NormalSetFlag ;									// @ZbgtO( @Zop )
	VECTOR					*Binormals ;										// ]@z
	VECTOR					*Tangents ;											// ڐz

	DWORD					VertexColorNum ;									// _J[̐
	COLOR_F					*VertexColors ;										// _J[z

	DWORD					UVNum[ MV1_READ_MAX_UV_NUM ] ;						// tu̐
	FLOAT4					*UVs[ MV1_READ_MAX_UV_NUM ] ;						// tuz( x=u y=v )

	DWORD					MaterialNum ;										// }eA̐
	MV1_MATERIAL_R			*Materials[ MV1_READ_MAX_MESH_MATERIAL_NUM ] ;		// }eȀւ̃|C^̔z

	DWORD					SkinWeightsNum ;									// XLbṼ{[̐
	MV1_SKIN_WEIGHT_R		*SkinWeights[ MV1_READ_MAX_MESH_SKINWEIGHT_NUM ] ;	// XLbVւ̃|C^z

	// Ro[gvOgp
	DWORD					MaxBoneUseNum ;										// (ǂݎp)̒_f[^uhĂ{[̍ő吔
	DWORD					TriangleNum ;										// (ǂݎp)Op`|S̐
	DWORD					TriangleListNum ;									// (ǂݎp)Op`|SXg̐
	DWORD					VertexDataTotalSize ;								// (ǂݎp)_f[^̑TCY
	DWORD					IndexDataTotalSize ;								// (ǂݎp)_CfbNXf[^̑TCY

	DWORD					TypeNumVertexDataSize[ MV1_VERTEX_TYPE_NUM ] ;		// (ǂݎp)e^Cv̒_f[^̑TCY
	DWORD					TypeNumIndexDataSize[ MV1_VERTEX_TYPE_NUM ] ;		// (ǂݎp)e^Cv̒_CfbNXf[^̑TCY

	BITLIST					SkinVerticesBlend ;									// (ǂݎp)e_ǂ̃{[̉e󂯂̂AnVertices ̐
	BITLIST					SkinFacesBlend ;									// (ǂݎp)eʂǂ̃{[̉e󂯂̂A nFaces ̐ 
	BYTE					*SkinFaceType ;										// (ǂݎp)gCAO^CvzAnFaces ̐
	float					*SkinVerticeWeightInfo ;							// (ǂݎp)e_̃{[EGCgl
	WORD					*SkinFaceBoneNum ;									// (ǂݎp)ebVɊւĂ{[̐
	WORD					*FaceUseTriangleList ;								// (ǂݎp)etFCXgpgCAOXgԍ
	MV1_MATERIAL_POLY_R		*MaterialPolyList ;									// (ǂݎp)}eÃ|S

//	VECTOR					*Binormals ;										// (ǂݎp)]@z
//	VECTOR					*Tangents ;											// (ǂݎp)ڐz

	DWORD					IsShapeMesh ;										// (ǂݎp)VFCvbVǂ

	struct MV1_FRAME_R		*Container ;										// (ǂݎp)̃bVĂt[
	MV1_MESH_R				*Next ;												// (ǂݎp)̃bV
	MV1_MESH_R				*Prev ;												// (ǂݎp)ÕbV
} ;

// VFCv_f[^\
struct MV1_SHAPE_VERTEX_R
{
	int						TargetPositionIndex ;			// Ώۂ̍Wf[^CfbNX( MV1_MESH_R.Positions z̗vfԍ )
	VECTOR					Position ;						// W( ̍Wɑ΂鍷 )
	VECTOR					Normal ;						// @( ̖@ɑ΂鍷 )
} ;

// VFCv\
struct MV1_SHAPE_R
{
	MV1_SHAPE_R				*DataPrev ;						// (ǂݎp)f[^IɑÕt[
	MV1_SHAPE_R				*DataNext ;						// (ǂݎp)f[^IɎ̃t[
	int						Index ;							// (ǂݎp)CfbNX
#ifndef UNICODE
	const char				*NameA ;						// (ǂݎp)O
#endif
	const wchar_t			*NameW ;						// (ǂݎp)O

	MV1_MESH_R				*TargetMesh ;					// ΏۃbV
	int						ValidVertexNormal ;				// _f[^̖@Lǂ( TRUE:L  FALSE: )
	int						VertexNum ;						// _̐
	MV1_SHAPE_VERTEX_R		*Vertex ;						// VFCv_Ŕzւ̃|C^

	DWORD					*NextTable ;					// (ǂݎp)VFCvΏۂ̍WvfɑΉ Vertex z̗vfԍi[ꂽe[u
	struct MV1_FRAME_R		*Container ;					// (ǂݎp)̃VFCvĂt[
	MV1_SHAPE_R				*Next ;							// (ǂݎp)̃bV
	MV1_SHAPE_R				*Prev ;							// (ǂݎp)ÕbV
} ;

// Zp̃f[^\
struct MV1_PHYSICS_RIGIDBODY_R
{
	MV1_PHYSICS_RIGIDBODY_R	*DataPrev ;						// (ǂݎp)f[^IɑO̍̃f[^
	MV1_PHYSICS_RIGIDBODY_R	*DataNext ;						// (ǂݎp)f[^IɎ̍̃f[^
	int						Index ;							// (ǂݎp)CfbNX
#ifndef UNICODE
	const char				*NameA ;						// (ǂݎp)O
#endif
	const wchar_t			*NameW ;						// (ǂݎp)O

	struct MV1_FRAME_R		*TargetFrame ;					// (ǂݎp)ΏۂƂȂt[

	int						RigidBodyGroupIndex ;			// ̃O[vԍ
	DWORD					RigidBodyGroupTarget ;			// ̃O[vΏ
	int						ShapeType ;						// `( 0:  1:  2:JvZ )
	float					ShapeW ;						// 
	float					ShapeH ;						// 
	float					ShapeD ;						// s
	VECTOR					Position ;						// ʒu
	VECTOR					Rotation ;						// ]( WA )
	float					RigidBodyWeight ;				// 
	float					RigidBodyPosDim ;				// ړ
	float					RigidBodyRotDim ;				// ]
	float					RigidBodyRecoil ;				// 
	float					RigidBodyFriction ;				// C
	int						RigidBodyType ;					// ̃^Cv( 0:BoneǏ]  1:Z  2:Z(Boneʒu킹) )
	int						NoCopyToBone ;					// {[̍s𕨗ɓKpȂǂ
} ;

// Zp̃WCgf[^\
struct MV1_PHYSICS_JOINT_R
{
	MV1_PHYSICS_JOINT_R		*DataPrev ;						// (ǂݎp)f[^IɑO̍̃WCgf[^
	MV1_PHYSICS_JOINT_R		*DataNext ;						// (ǂݎp)f[^IɎ̍̃WCgf[^
	int						Index ;							// (ǂݎp)CfbNX
#ifndef UNICODE
	const char				*NameA ;						// (ǂݎp)O
#endif
	const wchar_t			*NameW ;						// (ǂݎp)O

	DWORD					RigidBodyA ;					// ڑ捄̂`̃f[^CfbNX
	DWORD					RigidBodyB ;					// ڑ捄̂ãf[^CfbNX
	VECTOR					Position ;						// ʒu
	VECTOR					Rotation ;						// ]( WA )
	VECTOR					ConstrainPosition1 ;			// ړlP
	VECTOR					ConstrainPosition2 ;			// ړlQ
	VECTOR					ConstrainRotation1 ;			// ]lP
	VECTOR					ConstrainRotation2 ;			// ]lQ
	VECTOR					SpringPosition ;				// ΂ˈړl
	VECTOR					SpringRotation ;				// ΂ˉ]l
} ;

// f[^t[\
struct MV1_FRAME_R
{
	MV1_FRAME_R				*DataPrev ;						// (ǂݎp)f[^IɑÕt[
	MV1_FRAME_R				*DataNext ;						// (ǂݎp)f[^IɎ̃t[
	int						Index ;							// (ǂݎp)CfbNX(m[hǉƒlω\L)
#ifndef UNICODE
	const char				*NameA ;						// (ǂݎp)O
#endif
	const wchar_t			*NameW ;						// (ǂݎp)O

	int						TotalMeshNum ;					// (ǂݎp)̉wɂ郁bV̑
	int						TotalChildNum ;					// (ǂݎp)̉wɂt[̐

	int						Visible ;						// \A\ݒ( 0:\  1:\ )

	DWORD					UserID ;						// [U[ݒłhc
	void					*UserData ;						// [U[f[^

	VECTOR					TempVector ;					// ZbgAbvƂŎgĂėpxNg
	MATRIX					LocalWorldMatrix ;				// ZbgAbvƂŎgĂ[J[hϊs
	MATRIX					Matrix ;						// ϊs
	VECTOR					Translate ;						// sړ
	VECTOR					Scale ;							// XP[
	VECTOR					Rotate ;						// ]
	int						RotateOrder ;					// ]I[_[( MV1_ROTATE_ORDER_XYZ )
	FLOAT4					Quaternion ;					// ]( NH[^jI )
	int						IgnoreParentTransform ;			// e̍Wϊ𖳎邩ǂ( 1: 0:Ȃ )

	int						EnablePreRotate ;				// O]L( 1:L  0: )
	int						EnablePostRotate ;				// ]L( 1:L  0: )
	VECTOR					PreRotate ;						// O]
	VECTOR					PostRotate ;					// ]

	MV1_LIGHT_R				*Light ;						// Cg̏( Cgł͖ꍇ NULL )

	DWORD					MaxBoneUseNum ;					// (ǂݎp)̒_f[^uhĂ{[̍ő吔
	float					SmoothingAngle ;				// @X[WOʂƖʂ̍őpx( Pʂ̓WA )

	int						MeshNum ;						// (ǂݎp)bV̐
	MV1_MESH_R				*MeshFirst ;					// (ǂݎp)擪̃bVւ̃|C^
	MV1_MESH_R				*MeshLast ;						// (ǂݎp)[̃bVւ̃|C^

	int						ShapeNum ;						// (ǂݎp)VFCvf[^̐
	MV1_SHAPE_R				*ShapeFirst ;					// (ǂݎp)擪̃VFCvf[^ւ̃|C^
	MV1_SHAPE_R				*ShapeLast ;					// (ǂݎp)[̃VFCvf[^ւ̃|C^

	MV1_FRAME_R				*Parent ;						// (ǂݎp)em[h
	MV1_FRAME_R				*ChildFirst ;					// (ǂݎp)jm[h
	MV1_FRAME_R				*ChildLast ;					// (ǂݎp)qm[h
	MV1_FRAME_R				*Next ;							// (ǂݎp)m[h
	MV1_FRAME_R				*Prev ;							// (ǂݎp)Zm[h

	MV1_FRAME_BASE			*MV1Frame ;						// (ǂݎp)̃t[Ɋ֘Atꂽ MV1_FRAME_BASE \̂ւ̃|C^
} ;

// f[^\
struct MV1_MODEL_R
{
	MEMINFO					*Mem ;							// (ǂݎp)AhXۑf[^ւ̃|C^

	int						CharCodeFormat ;				// charł̃IuWFNgǉ֐Ă΂ꂽۂɑz肷镶R[h`
	wchar_t					*FilePath ;						// t@CpXւ̃|C^( ̕ MV1RAddString gpĂ͂Ȃ )
	wchar_t					*Name ;							// Oւ̃|C^( ̕ MV1RAddString gpĂ͂Ȃ )
	int						MeshFaceRightHand ;				// ʏ񂪉En̕тɂȂĂ邩ǂ( TRUE:ȂĂ  FALSE:ȂĂȂ )
	int						AutoCreateNormal ;				// @̎gp邩ǂ( TRUE:gp  FALSE:gpȂ )
	DWORD					AnimKeyDataSize ;				// Aj[VL[f[^̃TCY
	int						TranslateIsBackCulling ;		// obNJO邩ǂ( 1:  0:Ȃ )
	int						AnimDataNotDecomposition ;		// Ajf[^̕sȂǂ( 1:sȂ  0:s )
	int						MaterialNumberOrderDraw ;		// 蓖ĂĂ}eA̔ԍႢ̂`悷邩ǂ( 1:  0:Ȃ )

	int						TotalMV1MeshNum ;				// (ǂݎp)MV1_MESH_BASE Z̃bV̐
	int						ChangeDrawMaterialTableSize ;	// (ǂݎp)`}eA̕ύXǗpɕKvȃf[^̑e
	int						ChangeMatrixTableSize ;			// (ǂݎp)s̕ύXǗpɕKvȃf[^̑e

	DWORD					FrameNum ;						// (ǂݎp)m[h̐
	MV1_FRAME_R				*FrameFirst ;					// (ǂݎp)f[^Iɐ擪̃m[h
	MV1_FRAME_R				*FrameLast ;					// (ǂݎp)f[^Iɖ[̃m[h

	DWORD					MaterialNum ;					// (ǂݎp)}eA̐
	MV1_MATERIAL_R			*MaterialFirst ;				// (ǂݎp)f[^Iɐ擪̃}eA
	MV1_MATERIAL_R			*MaterialLast ;					// (ǂݎp)f[^Iɖ[̃}eA

	DWORD					TextureNum ;					// (ǂݎp)eNX`̐
	MV1_TEXTURE_R			*TextureFirst ;					// (ǂݎp)f[^Iɐ擪̃eNX`
	MV1_TEXTURE_R			*TextureLast ;					// (ǂݎp)f[^Iɖ[̃eNX`

	DWORD					MeshNum ;						// (ǂݎp)bV̐
	MV1_MESH_R				*MeshFirst ;					// (ǂݎp)f[^Iɐ擪̃bV
	MV1_MESH_R				*MeshLast ;						// (ǂݎp)f[^Iɖ[̃bV

	DWORD					ShapeNum ;						// (ǂݎp)VFCv̐
	MV1_SHAPE_R				*ShapeFirst ;					// (ǂݎp)f[^Iɐ擪̃VFCv
	MV1_SHAPE_R				*ShapeLast ;					// (ǂݎp)f[^Iɖ[̃VFCv

	DWORD					PhysicsRigidBodyNum ;			// (ǂݎp)Zp̂̐
	MV1_PHYSICS_RIGIDBODY_R	*PhysicsRigidBodyFirst ;		// (ǂݎp)f[^Iɐ擪̕Zp
	MV1_PHYSICS_RIGIDBODY_R	*PhysicsRigidBodyLast ;			// (ǂݎp)f[^Iɖ[̕Zp

	DWORD					PhysicsJointNum ;				// (ǂݎp)Zp̃WCg̐
	MV1_PHYSICS_JOINT_R		*PhysicsJointFirst ;			// (ǂݎp)f[^Iɐ擪̕Zp̃WCg
	MV1_PHYSICS_JOINT_R		*PhysicsJointLast ;				// (ǂݎp)f[^Iɖ[̕Zp̃WCg

	DWORD					LightNum ;						// (ǂݎp)Cg̐
	MV1_LIGHT_R				*LightFirst ;					// (ǂݎp)f[^Iɐ擪̃Cg
	MV1_LIGHT_R				*LightLast ;					// (ǂݎp)f[^Iɖ[̃Cg

	DWORD					AnimSetNum ;					// (ǂݎp)Aj[VZbg̐
	MV1_ANIMSET_R			*AnimSetFirst ;					// (ǂݎp)f[^Iɐ擪̃Aj[VZbg
	MV1_ANIMSET_R			*AnimSetLast ;					// (ǂݎp)f[^Iɖ[̃Aj[VZbg

	DWORD					AnimNum ;						// (ǂݎp)Aj[V̐
	MV1_ANIM_R				*AnimFirst ;					// (ǂݎp)f[^Iɐ擪̃Aj[V
	MV1_ANIM_R				*AnimLast ;						// (ǂݎp)f[^Iɖ[̃Aj[V

	DWORD					AnimKeySetNum ;					// (ǂݎp)Aj[VL[Zbg̐
	MV1_ANIMKEYSET_R		*AnimKeySetFirst ;				// (ǂݎp)f[^Iɐ擪̃Aj[VL[Zbg
	MV1_ANIMKEYSET_R		*AnimKeySetLast ;				// (ǂݎp)f[^Iɖ[̃Aj[VL[Zbg

	int						ShapeNormalPositionNum ;		// (ǂݎp)VFCvp{[񖳂Wf[^̐
	int						ShapeSkinPosition4BNum ;		// (ǂݎp)VFCvpS{[XLjObVWf[^̐
	int						ShapeSkinPosition8BNum ;		// (ǂݎp)VFCvpW{[XLjObVWf[^̐
	int						ShapeSkinPositionFREEBSize ;	// (ǂݎp)VFCvpX{[ȏXLjObVWf[^̃TCY

	DWORD					MeshMaterialNum ;				// (ǂݎp)bVŎgpĂ}eA̐
	DWORD					TriangleNum ;					// (ǂݎp)Rp`|S̐
	DWORD					TriangleListNum	;				// (ǂݎp)gCAOXg̐
	DWORD					IndexNum ;						// (ǂݎp)_CfbNX̐
	int						NormalPositionNum ;				// (ǂݎp){[񖳂Wf[^̐
	int						SkinPosition4BNum ;				// (ǂݎp)S{[XLjObVWf[^̐
	int						SkinPosition8BNum ;				// (ǂݎp)W{[XLjObVWf[^̐
	int						SkinPositionFREEBSize ;			// (ǂݎp)X{[ȏXLjObVWf[^̃TCY
	int						MeshPositionSize ;				// (ǂݎp)bVW̃f[^TCY
	int						MeshNormalNum ;					// (ǂݎp)bV@̐
	int						MeshVertexSize ;				// (ǂݎp)bV_̃f[^TCY
	int						MeshFaceNum ;					// (ǂݎp)bVʏ̐
	DWORD					MeshVertexIndexNum ;			// (ǂݎp)bV_f[^CfbNX̑
	DWORD					StringSizeA ;					// (ǂݎp)f[^̃TCY
	DWORD					StringSizeW ;					// (ǂݎp)f[^̃TCY
	DWORD					ShapeMeshNum ;					// (ǂݎp)VFCvbV̐
	DWORD					ShapeVertexNum ;				// (ǂݎp)VFCv_f[^̐

	DWORD					SkinWeightNum ;					// (ǂݎp)XLbṼEGCgɊւ̐
} ;

// ֐錾 -------------------------------------

extern	int					MV1InitReadModel( MV1_MODEL_R *ReadModel ) ;							// ǂݍݏpf\̂̏
extern	int					MV1TermReadModel( MV1_MODEL_R *ReadModel ) ;							// ǂݍݏpf\̂̌n

#ifndef UNICODE
extern	char				*MV1RAddString(					MV1_MODEL_R *ReadModel, const char    *String ) ;							// ̒ǉ
#endif
extern	wchar_t				*MV1RAddStringW(				MV1_MODEL_R *ReadModel, const wchar_t *String ) ;							// ̒ǉ
#ifndef UNICODE
extern	char				*MV1RAddStringWToA(				MV1_MODEL_R *ReadModel, const wchar_t *String ) ;							// ̒ǉ
#endif
extern	wchar_t				*MV1RAddStringAToW(				MV1_MODEL_R *ReadModel, const char    *String ) ;							// ̒ǉ
extern	MV1_FRAME_R			*MV1RAddFrame(					MV1_MODEL_R *ReadModel, const char    *Name, MV1_FRAME_R *Parent ) ;		// t[̒ǉ
extern	MV1_FRAME_R			*MV1RAddFrameW(					MV1_MODEL_R *ReadModel, const wchar_t *Name, MV1_FRAME_R *Parent ) ;		// t[̒ǉ
extern	MV1_MESH_R			*MV1RAddMesh(					MV1_MODEL_R *ReadModel, MV1_FRAME_R *Frame ) ;								// bV̒ǉ
extern	void				MV1RSubMesh(					MV1_MODEL_R *ReadModel, MV1_FRAME_R *Frame, MV1_MESH_R *Mesh ) ;			// bV̍폜
extern	int					MV1RSetupMeshFaceBuffer(		MV1_MODEL_R *ReadModel, MV1_MESH_R *Mesh, int FaceNum, int MaxIndexNum ) ;	// bV̖ʗp̃obt@ZbgAbv
extern	MV1_SHAPE_R			*MV1RAddShape(					MV1_MODEL_R *ReadModel, const char    *Name, MV1_FRAME_R *Frame ) ;			// VFCvf[^̒ǉ
extern	MV1_SHAPE_R			*MV1RAddShapeW(					MV1_MODEL_R *ReadModel, const wchar_t *Name, MV1_FRAME_R *Frame ) ;			// VFCvf[^̒ǉ
extern	MV1_PHYSICS_RIGIDBODY_R *MV1RAddPhysicsRididBody(	MV1_MODEL_R *ReadModel, const char    *Name, MV1_FRAME_R *TargetFrame ) ;	// Zp̃f[^̒ǉ
extern	MV1_PHYSICS_RIGIDBODY_R *MV1RAddPhysicsRididBodyW(	MV1_MODEL_R *ReadModel, const wchar_t *Name, MV1_FRAME_R *TargetFrame ) ;	// Zp̃f[^̒ǉ
extern	MV1_PHYSICS_JOINT_R *MV1RAddPhysicsJoint(			MV1_MODEL_R *ReadModel, const char    *Name ) ;								// Zp̃WCgf[^̒ǉ
extern	MV1_PHYSICS_JOINT_R *MV1RAddPhysicsJointW(			MV1_MODEL_R *ReadModel, const wchar_t *Name ) ;								// Zp̃WCgf[^̒ǉ
extern	MV1_MATERIAL_R		*MV1RAddMaterial(				MV1_MODEL_R *ReadModel, const char    *Name ) ;								// }eA̒ǉ
extern	MV1_MATERIAL_R		*MV1RAddMaterialW(				MV1_MODEL_R *ReadModel, const wchar_t *Name ) ;								// }eA̒ǉ
extern	MV1_MATERIAL_R		*MV1RGetMaterial(				MV1_MODEL_R *ReadModel, int Index ) ;										// wCfbNX̃}eA擾
extern	MV1_TEXTURE_R		*MV1RAddTexture(				MV1_MODEL_R *ReadModel, const char    *Name, const char    *ColorFilePath, const char    *AlphaFilePath = NULL, int BumpMapFlag = FALSE, float BumpMapNextPixelLength = 0.1f, bool FilePathDoubleCancel = true, bool ReverseFlag = false, bool Bmp32AllZeroAlphaToXRGB8Flag = true, bool OpenFailedReturn = false ) ;	// eNX`̒ǉ
extern	MV1_TEXTURE_R		*MV1RAddTextureW(				MV1_MODEL_R *ReadModel, const wchar_t *Name, const wchar_t *ColorFilePath, const wchar_t *AlphaFilePath = NULL, int BumpMapFlag = FALSE, float BumpMapNextPixelLength = 0.1f, bool FilePathDoubleCancel = true, bool ReverseFlag = false, bool Bmp32AllZeroAlphaToXRGB8Flag = true, bool OpenFailedReturn = false ) ;	// eNX`̒ǉ
extern	MV1_SKIN_WEIGHT_R	*MV1RAddSkinWeight( 			MV1_MODEL_R *ReadModel ) ;													// XL̒ǉ
extern	MV1_ANIMSET_R		*MV1RAddAnimSet(				MV1_MODEL_R *ReadModel, const char    *Name ) ;								// Aj[VZbg̒ǉ
extern	MV1_ANIMSET_R		*MV1RAddAnimSetW(				MV1_MODEL_R *ReadModel, const wchar_t *Name ) ;								// Aj[VZbg̒ǉ
extern	MV1_ANIM_R			*MV1RAddAnim(					MV1_MODEL_R *ReadModel, MV1_ANIMSET_R *AnimSet ) ;							// Aj[V̒ǉ
extern	MV1_ANIMKEYSET_R	*MV1RAddAnimKeySet(				MV1_MODEL_R *ReadModel, MV1_ANIM_R *Anim ) ;								// Aj[VL[Zbg̒ǉ
extern	MV1_LIGHT_R			*MV1RAddLight(					MV1_MODEL_R *ReadModel, const char    *Name ) ;								// Cg̒ǉ
extern	MV1_LIGHT_R			*MV1RAddLightW(					MV1_MODEL_R *ReadModel, const wchar_t *Name ) ;								// Cg̒ǉ
extern	int					MV1GetFrameIndex(				MV1_MODEL_R *ReadModel, DWORD UserID ) ;									// w̃t[hcm[h̃CfbNX𓾂
extern	int					MV1RLoadFile(  const char    *FilePath, void **FileImage, int *FileSize ) ;									// t@CۂƓǂݍ( -1:ǂݍݎs )
extern	int					MV1RLoadFileW( const wchar_t *FilePath, void **FileImage, int *FileSize ) ;									// t@CۂƓǂݍ( -1:ǂݍݎs )
extern	int					MV1RMakeMatrix( VECTOR *PreRotate, VECTOR *Rotate, VECTOR *PostRotate, VECTOR *Scale, VECTOR *Translate, VECTOR *MatrixRXYZ, MATRIX *DestBuffer, int RotateOrder = MV1_ROTATE_ORDER_XYZ ) ;	// Wϊs̍쐬

extern	int					MV1LoadModelToReadModel( const MV1LOADMODEL_GPARAM *GParam, MV1_MODEL_R *ReadModel, const wchar_t *CurrentDir, const MV1_FILE_READ_FUNC *ReadFunc, int ASyncThread ) ;	// ǂݍݏpf{ff[^쐬

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif	// DX_NON_MODEL

#endif

