// -------------------------------------------------------------------------------
// 
// 		cwCu		ff[^vO( Direct3D9 )wb_t@C
// 
// 				Ver 3.17e
// 
// -------------------------------------------------------------------------------

#ifndef __DXMODELD3D9_H__
#define __DXMODELD3D9_H__

#include "../DxCompileConfig.h"

#ifndef DX_NON_DIRECT3D9

// CN[h ------------------------------------------------------------------

#ifndef DX_NON_MODEL

#include "DxDirectX.h"
#include "../DxLib.h"
#include "../DxModel.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// ̃bV^Cv_\
struct MV1_VERTEX_SIMPLE_D3D9
{
	VECTOR					Position ;							// W
	VECTOR					Normal ;							// @
	COLOR_U8				DiffuseColor ;						// fBt[YF
	COLOR_U8				SpecularColor ;						// XyL[F
	float					UVs[ 3 ][ 4 ] ;						// eNX`W
} ;

// ̃bV^Cv֊sp_\
struct MV1_VERTEX_SIMPLE_TOL_D3D9
{
	VECTOR					Position ;							// W
	COLOR_U8				DiffuseColor ;						// fBt[YF
} ;

// ̃bV^Cvov}bvp_\
struct MV1_VERTEX_SIMPLE_BUMP_D3D9
{
	VECTOR					Position ;							// W
	VECTOR					Tangent ;							// _̐ڐ
	VECTOR					Binormal ;							// _̏]@
	VECTOR					Normal ;							// @
	COLOR_U8				DiffuseColor ;						// fBt[YF
	COLOR_U8				SpecularColor ;						// XyL[F
	float					UVs[ 1 ][ 4 ] ;						// eNX`W
} ;

// XLbV^Cv_\(֘A{[Sȓ)
struct MV1_VERTEX_SKIN_B4_D3D9
{
	VECTOR					Position ;							// W
	unsigned char			MatrixIndex[ 4 ] ;					// sCfbNX( sԍ~S )
	float					MatrixWeight[ 4 ] ;					// sEGCg
	VECTOR					Normal ;							// @
	COLOR_U8				DiffuseColor ;						// fBt[YF
	COLOR_U8				SpecularColor ;						// XyL[F
	float					UVs[ 1 ][ 4 ] ;						// eNX`W
} ;

// XLbV^Cvov}bvp_\(֘A{[Sȓ)
struct MV1_VERTEX_SKIN_B4_BUMP_D3D9
{
	VECTOR					Position ;							// W
	unsigned char			MatrixIndex[ 4 ] ;					// sCfbNX( sԍ~S )
	float					MatrixWeight[ 4 ] ;					// sEGCg
	VECTOR					Tangent ;							// _̐ڐ
	VECTOR					Binormal ;							// _̏]@
	VECTOR					Normal ;							// @
	COLOR_U8				DiffuseColor ;						// fBt[YF
	COLOR_U8				SpecularColor ;						// XyL[F
	float					UVs[ 1 ][ 4 ] ;						// eNX`W
} ;

// XLbV^Cv_\(֘A{[Wȓ)
struct MV1_VERTEX_SKIN_B8_D3D9
{
	VECTOR					Position ;							// W
	unsigned char			MatrixIndex[ 8 ] ;					// sCfbNX( sԍ~S )
	float					MatrixWeight[ 8 ] ;					// sEGCg
	VECTOR					Normal ;							// @
	COLOR_U8				DiffuseColor ;						// fBt[YF
	COLOR_U8				SpecularColor ;						// XyL[F
	float					UVs[ 1 ][ 4 ] ;						// eNX`W
} ;

// XLbV^Cvov}bvp_\(֘A{[Wȓ)
struct MV1_VERTEX_SKIN_B8_BUMP_D3D9
{
	VECTOR					Position ;							// W
	unsigned char			MatrixIndex[ 8 ] ;					// sCfbNX( sԍ~W )
	float					MatrixWeight[ 8 ] ;					// sEGCg
	VECTOR					Tangent ;							// _̐ڐ
	VECTOR					Binormal ;							// _̏]@
	VECTOR					Normal ;							// @
	COLOR_U8				DiffuseColor ;						// fBt[YF
	COLOR_U8				SpecularColor ;						// XyL[F
	float					UVs[ 1 ][ 4 ] ;						// eNX`W
} ;

// Direct3D9p ff[^Ǘp\
struct MV1_MODEL_MANAGE_DIRECT3D9
{
	int Dummy ;
} ;

// Direct3D9p_obt@
struct MV1_VERTEXBUFFER_DIRECT3D9
{
	DWORD						FVF ;							// _obt@쐬Ɏgpeue
	D_IDirect3DVertexBuffer9	*VertexBuffer ;					// _obt@
	D_IDirect3DIndexBuffer9		*IndexBuffer ;					// CfbNXobt@
} ;

// Direct3D9pgCAOXgf[^
struct MV1_TRIANGLE_LIST_BASE_DIRECT3D9
{
	MV1_VERTEX_SIMPLE_D3D9		*TempSimpleVertex ;					// VF[_[gpɕ`悷ꍇ̒_f[^
	MV1_VERTEX_SIMPLE_TOL_D3D9	*TempToonOutLineSimpleVertex ;		// VF[_[gpɕ`悷ꍇ̃gD[̗֊s`p_f[^
} ;

// Direct3D9pgCAOXg
struct MV1_TRIANGLE_LIST_DIRECT3D9
{
	D_IDirect3DVertexBuffer9	*VertexBuffer ;					// _obt@
} ;

// ϐ錾 --------------------------------------------------------------

extern MV1_MODEL_MANAGE_DIRECT3D9 MV1Man_D3D9 ;

// ֐vg^Cv錾-----------------------------------------------------------

// ˑ֐
extern	int				MV1_D3D9_Terminate_PF( void ) ;																// f@\̌n
extern	int				MV1_D3D9_TerminateModelBaseHandle_PF( MV1_MODEL_BASE *ModelBase ) ;							// ff[^nȟn
extern	int				MV1_D3D9_TerminateTriangleListBaseTempBuffer_PF( MV1_TRIANGLE_LIST_BASE *MBTList ) ;				// gCAOXg̈ꎞp̃obt@J
extern	void			MV1_D3D9_SetupPackDrawInfo_PF( MV1_MODEL_BASE *ModelBase ) ;								// `֌W̏ZbgAbv
extern	int				MV1_D3D9_SetupVertexBufferBase_PF( int MV1ModelBaseHandle, int DuplicateNum = 1, int ASyncThread = FALSE ) ;	// ff[^̒_obt@̃ZbgAbv( -1:G[ )
extern	int				MV1_D3D9_SetupVertexBuffer_PF( int MHandle, int ASyncThread = FALSE ) ;						// ff[^̒_obt@̃ZbgAbv( -1:G[ )
extern	int				MV1_D3D9_TerminateVertexBufferBase_PF( int MV1ModelBaseHandle ) ;							// _obt@̌n( -1:G[ )
extern	int				MV1_D3D9_TerminateVertexBuffer_PF( int MV1ModelHandle ) ;									// _obt@̌n( -1:G[ )
extern	int				MV1_D3D9_SetupShapeVertex_PF( int MHandle ) ;												// VFCvf[^̃ZbgAbv
extern	int				MV1_D3D9_BeginRender_PF( MV1_MODEL *Model ) ;												// Rcf̃_Ȍs
extern	int				MV1_D3D9_EndRender_PF( void ) ;																// Rcf̃_Ǒns
extern	void			MV1_D3D9_DrawMesh_PF( MV1_MESH *Mesh, int TriangleListIndex = -1 ) ;						// bV`敔𔲂o

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_MODEL

#endif // DX_NON_DIRECT3D9

#endif // __DXMODELD3D9_H__
